clear
clc
s=tf('s');
a=0.78;
b=0.4;
num=-6.475*s^2+4.0302*s+175.77;
den=5*s^4+3.5682*s^3+139.5021*s^2+.0929*s+10^-6;
G=num/den;
Ws=a*(s^2+1.2*s+1)/((s+.001)*(s+1.2)*(.001*s+1));
Wu=b*(s+1)/(s+0.1);
W=10*(s+1)/(s+20);
P=augw(G,Ws,Wu,W);
[k2,g2,gamma2,info2]=hinfsyn(P,'TOLGAM',.001,'Display','on');
k2=zpk(minreal(k2))
figure(1)
clf
omega=logspace(-1,5,500);
[mag_g2,phase_g2]=bode(g2,omega);
sig_g2=sigma(g2,omega);
semilogx(omega,sig_g2,omega,mag_g2(1,:),'--r', ...
    omega,mag_g2(2,:),'-.k', omega,mag_g2(3,:),':m')
clf
bodemag(k2,omega)
title('Bode plot of controller, k2')

delta = ultidyn('delta',[1 1]);
Gp = (1+delta*W)*G;
G1=usample(Gp,1);
