clear
clc
a=0.89;
s=zpk('s');
G=(s-2)*(s+2)/((s+1e-3)^2*(s-4)*(s+4));
Ws=a/20*(s+5)/(s+0.05);
Wu=1e-3*(s+0.10)/(s+1);
W=2*(s+1)/(s+100);
P=augw(G,Ws,Wu,W);
[k1,g1,gamma1,info1]=hinfsyn(P,'Display','on','Tolgam',.001);
k1=zpk(minreal(k1));
omega=logspace(-1,5,500);
[mag_g1,phase_g1]=bode(g1,omega);
sig_g1=sigma(g1,omega);
semilogx(omega,sig_g1,omega,mag_g1(1,:),'--r', ...
    omega,mag_g1(2,:),'-.k', omega,mag_g1(3,:),':m')
clf
bodemag(k1,omega)
title('Bode plot of controller, k1')
delta = ultidyn('delta',[1 1]);
Gp = (1+delta*W)*G;
G1=usample(Gp,1);

A=[0 1 0 0;0 0 -30 0;0 0 0 1;0 0 16 0];
B=[0;1;0;-.4];
C=[1 0 0 0;0 1 0 0;0 0 1 0;0 0 0 1];
D=[0;0;0;0];
