clear 
clc
a=0.94; kk=0.4;
s=zpk('s');
G1=-kk/((s-4)*(s+4));
Ws=a*(s+200)/(25*(s+2));
Wu=1e-3;
W=2*(s+1)/(s+100);
P1=augw(G1,Ws,Wu,W);
[k1,g1,gamma1,info1]=hinfsyn(P1,'Display','on','Tolgam',.001);
k1=zpk(minreal(k1));
omega=logspace(-1,5,500);
[mag_g1,phase_g1]=bode(g1,omega);
sig_g1=sigma(g1,omega);
semilogx(omega,sig_g1,omega,mag_g1(1,:),'--r', ...
    omega,mag_g1(2,:),'-.k', omega,mag_g1(3,:),':m')
legend('\sigma_{max}','W_s S','W_u U','W T')
clf
bodemag(k1,omega)
title('Bode plot of controller, k1')

a=0.88;
G2=-(s-2)*(s+2)/kk/(s+1e-3)^2;
GT=k1*G1*G2/(1+k1*G1);
GT=minreal(GT);
Ws=a*(s+20)/(10*(s+0.2));
Wu=1*(s+1)/(s+100);
W=0.2*(s+1)/(s+100);
P2=augw(GT,Ws,Wu,W);
[k2,g2,gamma2,info2]=hinfsyn(P2,'Display','on','Tolgam',.001);

figure(2)
clf
omega=logspace(-1,5,500);
[mag_g2,phase_g2]=bode(g2,omega);
sig_g2=sigma(g2,omega);
semilogx(omega,sig_g2,omega,mag_g2(1,:),'--r', ...
    omega,mag_g2(2,:),'-.k', omega,mag_g2(3,:),':m')
legend('\sigma_{max}','W_s S','W_u U','W T')

clf
bodemag(k2,omega)
title('Bode plot of controller, k2')

delta = ultidyn('delta',[1 1]);
delta1=usample(delta,1);

A=[0 1 0 0;0 0 -30 0;0 0 0 1;0 0 16 0];
B=[0;1;0;-.4];
C=[1 0 0 0;0 1 0 0;0 0 1 0;0 0 0 1];
D=[0;0;0;0];